import 'dart:async';

import 'package:device_apps/device_apps.dart';
import 'package:flutter/services.dart';

part 'application_resume.dart';

class Apklisinfo {
  static String packageName = 'cu.uci.android.apklis';
  static const channel = MethodChannel('apklisinfo');

  ///
  /// Get apklis info
  ///
  static Future<ApplicationResume> getApklisInfo() async {
    Application? app = await DeviceApps.getApp(Apklisinfo.packageName);
    if (app != null) {
      return ApplicationResume(
        installed: true,
        enabled: app.enabled,
        versionCode: app.versionCode,
        versionName: app.versionName,
      );
    } else {
      return ApplicationResume(
        installed: false,
      );
    }
  }

  ///
  /// Get application info
  ///
  static Future<ApplicationResume> getAppInfo(String packageName) async {
    Application? app = await DeviceApps.getApp(packageName);
    if (app != null) {
      return ApplicationResume(
        installed: true,
        enabled: app.enabled,
        versionCode: app.versionCode,
        versionName: app.versionName,
      );
    } else {
      return ApplicationResume(
        installed: false,
      );
    }
  }

  ///
  /// Check if any application is payed into apklis
  ///
  static Future<bool> isPayed(String packageName) async {
    final Map? map = await (channel.invokeMapMethod('isPurchased', packageName));

    if (map != null) {
      if(map['paid'] != null && map['username'] != null) {
        return map['paid'];
      }
    }

    return false;
  }
}
